; nasm -t -O3 -f bin -o clk.com clk.asm

;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
CR		equ	0dh
LF		equ	0ah
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
		cpu	8086
		section	.text
		org	100h
offset_0100:
;-----------------------------------------------------------------------------
		jmp	install
;-----------------------------------------------------------------------------

last_code	db	0
run_flag	db	0
old_ss		dw	0
old_sp		dw	0
old_int09h	dd	0		;Old INT 09h vector

;-----------------------------------------------------------------------------
int09h_handler:
		push	ds
		push	ax
		cmp	byte [cs:run_flag],1
		je	@@to_old_handler

		in	al,60h
		cmp	al,[cs:last_code]
		je	@@to_old_handler

		cmp	al,0e0h		;Ignore ext. scancodes
		je	@@to_old_handler

		mov	[cs:last_code],al

		mov	byte [cs:run_flag],1
		mov	ax,cs
		mov	ds,ax
		mov	[old_ss],ss	;Save old SS:SP
		mov	[old_sp],sp
		mov	ss,ax		;Set new stack
		mov	sp,stack_bottom
		sti

		call	beep

		cli
		mov	ss,[old_ss]	;Restore old stack
		mov	sp,[old_sp]
		mov	byte [cs:run_flag],0

@@to_old_handler:
		pop	ax
		pop	ds
		jmp	far [cs:old_int09h]

;=============================================================================
beep:
		push	ax
		push	bx
		push	cx
		pushf
		mov	bx,5000		;Freq. divider
		mov	cx,500		;Duration
		sti
		in      al,61h
		or      al,3
		out     61h,al

		mov     al,10110110b
		out     43h,al
		mov     ax,bx
		out     42h,al
		mov     al,ah
		out     42h,al

		mov     al,0
		out     43h,al
		in      al,40h
		mov     ah,al
		nop
		in      al,40h
		xchg    al,ah
		mov     bx,ax
@@lbeep:
		mov     al,0
		out     43h,al
		in      al,40h
		mov     ah,al
		nop
		in      al,40h
		xchg    al,ah
		xchg    ax,bx
		sub     ax,bx
		jc      @@lbeep
		sub     cx,ax
		ja      @@lbeep

		in      al,61h
		and     al,0fch
		out     61h,al
		popf
		pop	cx
		pop	bx
		pop	ax
		ret

;=============================================================================
; Startup code
;-----------------------------------------------------------------------------
install:
		cld

		mov	ax,3509h
		int	21h
		mov	[old_int09h],bx
		mov	[old_int09h+2],es

		cli
		mov	ax,2509h
		mov	dx,int09h_handler
		int	21h
		sti

		mov	ax,[cs:2ch]
		mov	es,ax
		mov	ah,49h		;Free environment segment
		int	21h

		push	cs
		pop	ds

		mov	si,inst_ok_msg
		call	dos_print

		mov	dx,end_of_resident
		int	27h		;Terminate and stay resident

;=============================================================================
dos_print:
		push	ax
		push	dx
		mov	ah,2
@@next_byte:
		lodsb
		or	al,al
		jz	@@quit
		cmp	al,LF
		jne	@@print
		mov	dl,CR
		int	21h
		mov	al,LF
@@print:
		mov	dl,al
		int	21h
		jmp	@@next_byte
@@quit:
		pop	dx
		pop	ax
		ret

;=============================================================================
inst_ok_msg	db	"Installed.", LF, 0

		absolute	install
new_stack	resw	128		;Program's stack
stack_bottom:				;Bottom of stack
end_of_resident:			;Last byte of program in memory
;
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
; E0F
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

